/***************************************************************************
                          cconfig.cpp  -  description
                             -------------------
    begin                : Sun Nov 21 1999
    copyright            : (C) 1999 by Tiberiu Craciun
    email                : tiberiu@akela.ro
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qdir.h>
#include "cconfig.h"
#include <iostream.h>
#include <qregexp.h>
#include <kprocess.h>

CConfig::CConfig(QString file)
  : config( file ){
	
	cfgfile = file;
}
CConfig::~CConfig(){
}

/*-------------------------------------- CConfig::writeGroupEntry()
 * writeGroupEntry()
 *   Write an entry to the project file.
 *
 * Parameters:
 *   group          Name of the group.
 *   tag            The value-tag e.g version.
 *   entry          The string to store.
 *
 * Returns:
 *   -
 *-----------------------------------------------------------------*/
void CConfig::writeGroupEntry( const char *group, const char *tag, const char *entry )
{
  config.setGroup( group );
  config.writeEntry( tag, entry );
}

/*-------------------------------------- CConfig::readGroupEntry()
 * writeGroupEntry()
 *   Read an entry from the project file and return it.
 *
 * Parameters:
 *   group          Name of the group.
 *   tag            The value-tag e.g version.
 *
 * Returns:
 *   QString        The value.
 *-----------------------------------------------------------------*/
QString CConfig::readGroupEntry( const char *group, const char *tag )
{
  config.setGroup( group );
  return config.readEntry( tag,"" );
}



