/***************************************************************************
                          cserver.cpp  -  description
                             -------------------
    begin                : Sun Nov 21 1999
    copyright            : (C) 1999 by Tiberiu Craciun
    email                : tiberiu@akela.ro
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "cserver.h"
#include "qdir.h"
#include "qstrlist.h"
#include <qfile.h>
#include <qfileinfo.h>
#include <ksimpleconfig.h>


/**  */
void delFiles(CServer *server,QString directory ){
    QDir theDir( directory );
    QStrList fl;
    QString f;

    // del all files for this directory
    theDir.setFilter(QDir::Files);
    fl=*(theDir.entryList());

		f="";
		for( fl.first(); fl.current(); fl.next() ) {
//			server->info("FILE  ->%s<-",qstrdup(directory+"/"+fl.current()));
			remove(directory+"/"+fl.current());
				
		}
//	server->info("FILES rez ->%s<-",qstrdup(f));
}



void delDirs(CServer *server,QString directory ){
	QString dirs;
  QStrList dirList;
  QDir dir(directory);
  QDir thisDir;

  // Stop recursion if the directory doesn't exist.
  if (!dir.exists()) {
    return ;
  }

  dir.setSorting(QDir::Name);
  dir.setFilter(QDir::Dirs);
  dirList = *(dir.entryList());

  // Remove '.' and  '..'
  dirList.first();
  dirList.remove();
  dirList.remove();
  dirs=directory;
  // Recurse through all directories
  while( dirList.current() )
  {
    dirs=directory+"/"+dirList.current();
//    server->info("dirs %s",qstrdup(dirs));
    delDirs(server,dirs);
    delFiles(server,dirs);
    thisDir.rmdir(dirs);

    dirList.next();
  }
//    thisDir.rmdir(directory);
//	info("DIRS rez ->%s<-",n);
		

}




QString getDirFromPath(QString path){
	path=path.stripWhiteSpace();
	int index;
	index=path.findRev("/",path.length());
	return path.left(index)+"/";
}

QString getFileFromPath(QString path){
	path=path.stripWhiteSpace();
	int index;
	index=path.findRev("/",path.length());
	return path.right(path.length()-index);
}

int CServer::AddFile(char *filename,QString *prj){
    QString path(Path(prj)+filename);
    FILE *fis=fopen(path,"a+");
    fclose(fis);
	return 1;
}

int CServer::DelFile(char *filename, QString *prj){
    QString path(Path(prj)+filename);
    remove(path);
	return 1;
}

int CServer::AddDir(char *dirname,QString *prj){
    QString path(Path(prj)+dirname);
  QDir theDir( path );
  if(!theDir.exists()){
  	theDir.mkdir(path);
  }
  info("ADDDIR %s",qstrdup(path));
	return 1;
}

int CServer::DelDir(char *dirname,QString *prj){
    QString path(Path(prj)+dirname);
  QDir theDir( path );
  if(theDir.exists()){
    delDirs(this,path);
    delFiles(this,path);
 	theDir.rmdir(path);
  }
  info("DELDIR %s",qstrdup(path));
  return 1;
}


int CServer::HaveAccess(){

    return 1;
}

int CServer::Lock(char *filename,FILE *out,QString *prj, int client_socket_fd){
  QString path( Path(prj)+filename );

  QString dir(getDirFromPath(path));
  QString fis(getFileFromPath(path));
	KSimpleConfig conf(dir+"KPHPDEV.LOCK/"+fis);
//  info("check '%s' - '%s' - '%s'",qstrdup(path),qstrdup(dir),qstrdup(file));

  char n[2];
  n[1]='\0';

  QDir theDir( dir+"KPHPDEV.LOCK" );
  if(!theDir.exists()){
  	theDir.mkdir(dir+"KPHPDEV.LOCK");
  }
  if(theDir.exists()) {
  	QFile f(dir+"KPHPDEV.LOCK/"+fis);
  	if(f.exists()){
  		
  		conf.setGroup("General");
  		QString who=conf.readEntry("Lock");
  		if(who.isEmpty() || who.isNull() )
  				n[0]='0';
  		else {
  				QString peeradr(get_peer_addr(client_socket_fd));
  				if(who==peeradr)
  						n[0]='1';
  				else
  						n[0]='2';
  		}
  	} else {
  		n[0]='0';
  	}
  } else {
		n[0]='0';
  }

	if(n[0]=='0'){
		conf.setGroup("General");
		conf.writeEntry("Lock",get_peer_addr(client_socket_fd));
		conf.sync();
		n[0]='1';
	}

  write(fileno(out),n,1);
  return 1;
}

int CServer::Unlock(char *filename,FILE *out,QString *prj, int client_socket_fd){
  QString path( Path(prj)+filename );

  QString dir(getDirFromPath(path));
  QString fis(getFileFromPath(path));
	KSimpleConfig conf(dir+"KPHPDEV.LOCK/"+fis);
//  info("check '%s' - '%s' - '%s'",qstrdup(path),qstrdup(dir),qstrdup(file));

  char n[2];
  n[1]='\0';

  QDir theDir( dir+"KPHPDEV.LOCK" );
  if(theDir.exists()) {
  	QFile f(dir+"KPHPDEV.LOCK/"+fis);
  	if(f.exists()){
  		
  		conf.setGroup("General");
  		QString who=conf.readEntry("Lock");
  		if(who.isEmpty() || who.isNull() ){
  				n[0]='0';
  		} else {
  				QString peeradr(get_peer_addr(client_socket_fd));
  				if(who==peeradr) {
  						n[0]='1';
  				} else {
  						n[0]='2';
  				}
  		}
  	} else {
  		n[0]='0';
  	}
  } else {
  		n[0]='0';
  }	

//		info("UNLOCK %c",n[0]);
	if(n[0]=='0' || n[0]=='1'){
		conf.setGroup("General");
		conf.writeEntry("Lock","");
		conf.deleteEntry("Lock",FALSE);
		conf.sync();
//		info("UNLOCK %c",n[0]);
		n[0]='1';
	}

  write(fileno(out),n,1);
  return 1;
}

int CServer::ChangePassword(char *user,char *pass){
	return 1;
}

int CServer::AddUser(char *user){
	return 1;
}

int CServer::SendFile(char* fname,FILE *out, QString *prj) {
    char buf[2049];
    int bytes_read=1;
		QString fn("");
		char *filename;
		unsigned char br;

		fn=Path(prj);
		fn+=fname;
		
		filename=qstrdup(fn);
    FILE *fis=fopen(filename,"r");
    if(fis){
      fwrite("1",1,1,out);
    	while(bytes_read){
        bytes_read=read(fileno(fis),buf,250);
        br=bytes_read;
        fwrite((char*)&br,1,1,out);
				write(fileno(out),buf,bytes_read);
    	}
//  		info("Fisierul %s a fost trimis ",filename);
	   	fclose(fis);
    }
    else {
			fwrite("0",1,1,out);
//			info("Fisierul %s nu este gasit ",filename);
    }
    return 0;
}

int CServer::PutFile(char* fname,FILE *in, QString *prj) {
    char b[300];
    unsigned char n;
		QString fn("");
		char *filename;
	//	int i;

		fn=Path(prj);
		fn+=fname;

		filename=qstrdup(fn);
    n=fgetc(in);
    FILE *fis=fopen(filename,"w");
    while(n>0){
//    		info("%i",int(n));
        fread(b,(int)(n),1,in);
//         for (i=0; i<(int)(n); i++) info ("%c",b[i]);

				write(fileno(fis),b,n);
				n=fgetc(in);
    }
    fclose(fis);
    return 0;
}

char* CServer::GetCommand(FILE *in){
    return receive(in);
}

int CServer::InterpretCommand(char* cmd,FILE *in,FILE *out, QString *prj,int client_socket_fd ) {
    int ret=0;

    if(strcmp("quit",cmd)==0){
			info("QUIT %s",get_peer_addr(client_socket_fd));
			ret=1;
    }

    if(strcmp("get",cmd)==0){
			char *filename=receive(in);
//			info("GET %s",filename);
			if(HaveAccess()) SendFile(filename,out, prj);
			free(filename);
    }

    if(strcmp("put",cmd)==0){
			char *filename=receive(in);
//			info("PUT %s",filename);
			if(HaveAccess()) PutFile(filename,in,prj);
			free(filename);
    }

    if(strcmp("user",cmd)==0){
			username=receive(in);
//			info("USER %s",username);
    }

    if(strcmp("pass",cmd)==0){
			password=receive(in);
//			info("PASS %s",password);
    }

    if(strcmp("lock",cmd)==0){
			char *filename=receive(in);
			if(HaveAccess()) Lock(filename,out,prj,client_socket_fd);
//			info("LOCK %s",filename);
			free(filename);
    }

    if(strcmp("unlock",cmd)==0){
			char *filename=receive(in);
			if(HaveAccess()) Unlock(filename,out,prj,client_socket_fd);
//			info("UNLOCK %s",filename);
			free(filename);
    }

    if(strcmp("chpass",cmd)==0){
			char *user=receive(in);
			char *pass=receive(in);
			if(HaveAccess()) ChangePassword(user,pass);
//			info("CHPASS %s -> %s",user,pass);
			free(pass);
			free(user);
    }

    if(strcmp("newuser",cmd)==0){
			char *user=receive(in);
			if(HaveAccess()) AddUser(user);
//			info("NEWUSER %s",user);
			free(user);
    }

    if(strcmp("addfile",cmd)==0){
			char *filename=receive(in);
			if(HaveAccess()) AddFile(filename,prj);
//			info("ADDFILE %s",filename);
			free(filename);
    }

    if(strcmp("delfile",cmd)==0){
			char *filename=receive(in);
			if(HaveAccess()) DelFile(filename,prj);
//			info("DELFILE %s",filename);
			free(filename);
    }

    if(strcmp("adddir",cmd)==0){
			char *dirname=receive(in);
			if(HaveAccess()) AddDir(dirname,prj);
//			info("ADDDIR %s",dirname);
			free(dirname);
    }

    if(strcmp("deldir",cmd)==0){
			char *dirname=receive(in);
			if(HaveAccess()) DelDir(dirname,prj);
//			info("DELDIR %s",dirname);
			free(dirname);
    }

    if(strcmp("project",cmd)==0){
			QString proj(receive(in)),a;
			if(HaveAccess()){
				CPrjConf *pc;
				for ( pc=prjList.first(); pc != 0 && *pc->code!=proj; pc=prjList.next() );
				if(pc!=0) {
					*prj=*pc->path;
				}
				else ret=1;
			}
//			info("PROJECT %s - %s",qstrdup(proj),qstrdup(*prj));
    }

    if(strcmp("projects",cmd)==0){
			QString a;
			if(HaveAccess()){
				CPrjConf *pc;
				a="";
				for ( pc=prjList.first(); pc != 0; pc=prjList.next() ){
					if(pc!=0) {
						a+="/";
						a+=*pc->code;
					}
				}
				char *n=qstrdup(a);
			  write(fileno(out),n,strlen(n)+1);
				free(n);
//				info("PROJECTS %s",n);
				}
					
				else ret=1;
//			}
//			info("PROJECT %s - %s",qstrdup(proj),qstrdup(*prj));
    }

    if(strcmp("wwwroot",cmd)==0){
			if(HaveAccess()){
				*prj="";
			}
					else ret=1;
//			}
//			info("PROJECT %s - %s",qstrdup(proj),qstrdup(*prj));
    }


    if(strcmp("dirs",cmd)==0){
			QString directory(receive(in));
			if(HaveAccess()){
					GetDirs(directory,out,prj);
				}
				else ret=1;
//			info("DIRS %s ",qstrdup(directory));
    }

    if(strcmp("files",cmd)==0){
			QString directory(receive(in));
			if(HaveAccess()){
					GetFiles(directory,out,prj);
				}
				else ret=1;
//			info("FILES %s ",qstrdup(directory));
    }

    if(strcmp("check",cmd)==0){
			QString directory(receive(in));
			if(HaveAccess()){
					CheckFile(directory,out,prj,client_socket_fd);
				}
				else ret=1;
//			info("CHECK %s ",qstrdup(directory));
    }

    return ret;
}

char* CServer::receive(FILE *in){
    char *buf,b[2048];
    unsigned char n;
    n=fgetc(in);
    buf=(char*)malloc(16000);
    buf=strcpy(buf,"");
    while(n>0){
        fgets(b,(int)(n+1),in);
				buf=strncat(buf,b,(int)(n));
				n=fgetc(in);
    }
    return (buf);
}

void CServer::handle_client(int client_socket_fd)
 {
  int quit=0;
  char *cmd;
	QString *prj=new QString("");

  info("connect from %s ", get_peer_addr(client_socket_fd));

  FILE *in  = fdopen(client_socket_fd, "r");
  FILE *out  = fdopen(client_socket_fd, "w");

  setbuf(in, NULL);
  setbuf(out, NULL);

  if(!in)
   {
    warn("fdopen failed on 'in': %s\n", strerror(errno));
    return;
   }

  if(!out)
   {
    warn("fdopen failed on 'out': %s\n", strerror(errno));
    return;
   }
   do{
       cmd=GetCommand(in);
       quit=InterpretCommand(cmd,in,out,prj,client_socket_fd);
       free(cmd);
   } while (!quit);
 }



QString CServer::Path(QString *prj){
	QString tmp(wwwRoot);
//	info("prj path %s",qstrdup(*prj));
	if(!(prj->isNull() || prj->isEmpty()) ) {
		return *prj;
	} else {
		return tmp;
	}
}





/**  */
int CServer::ChangeProject(char *prj){
	return 1;
}


/**  */
int CServer::addProject(QString code, QString path){
	prjList.append( new CPrjConf(code,path) );
	return 1;
}


/**  */
int CServer::GetDirs(QString directory,FILE *out, QString *prj ){
	QString dirs;
  QStrList dirList;
  QDir dir(Path(prj)+directory);

  // Stop recursion if the directory doesn't exist.
  if (!dir.exists()) {
    return 1;
  }

  dir.setSorting(QDir::Name);
  dir.setFilter(QDir::Dirs);
  dirList = *(dir.entryList());

  // Remove '.' and  '..'
  dirList.first();
  dirList.remove();
  dirList.remove();
  dirs="";
  // Recurse through all directories
  while( dirList.current() )
  {
    dirs+=dirList.current();
		dirs+="//";

    dirList.next();
  }
	char *n=qstrdup(dirs);
  write(fileno(out),n,strlen(n)+1);
//	info("DIRS rez ->%s<-",n);
	free(n);
		

}

/**  */
int CServer::GetFiles(QString directory,FILE *out, QString *prj ){
    QDir theDir( Path(prj)+directory );
    QStrList fl;
    QString f;

    // Add all files for this directory
    theDir.setFilter(QDir::Files);
    fl=*(theDir.entryList());

		f="";
		for( fl.first(); fl.current(); fl.next() ) {
				f+=fl.current();
				f+="//";
		}
	char *n=qstrdup(f);
  write(fileno(out),n,strlen(n)+1);
//	info("FILES rez ->%s<-",qstrdup(f));
}


int CServer::CheckFile(QString file,FILE *out, QString *prj, int client_socket_fd ){

  QString path( Path(prj)+file );

  QString dir(getDirFromPath(path));
  QString fis(getFileFromPath(path));

//  info("check '%s' - '%s' - '%s'",qstrdup(path),qstrdup(dir),qstrdup(file));

  char n[2];
  n[1]='\0';

  QDir theDir( dir+"KPHPDEV.LOCK" );
  if(theDir.exists()) {
  	QFile f(dir+"KPHPDEV.LOCK/"+fis);
  	if(f.exists()){
  		KSimpleConfig conf(dir+"KPHPDEV.LOCK/"+fis);
  		
  		conf.setGroup("General");
  		QString who=conf.readEntry("Lock");
  		if(who.isEmpty() || who.isNull() ){
  				n[0]='0';
//  				info("Este gol LOCK");
  		} else {
  				QString peeradr(get_peer_addr(client_socket_fd));
  				if(who==peeradr) {
  						n[0]='1';
//  						info("Este aceasi adresa");
  				} else {
  						n[0]='2';
//  						info("Nu este aceasi adresa");
  				}
  		}
  	} else {
  		n[0]='0';
//  		info("Nu exista fisierul");
  	}
  } else {
		n[0]='0';
//		info("Nu exista directorul");
  }



//  info("Raspuns %c",n[0]);
  write(fileno(out),n,1);
  return 1;
}
