/***************************************************************************
                          cserver.h  -  description
                             -------------------
    begin                : Sun Nov 21 1999
    copyright            : (C) 1999 by Tiberiu Craciun
    email                : tiberiu@akela.ro
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CSERVER_H
#define CSERVER_H

#include <qstring.h>
#include <qstrlist.h>
#include <qfile.h>
#include <qtextstream.h>
#include <qfileinfo.h>

#include <fstream.h>
#include <iostream.h>

#include "tcp_server.h"

/**
  *@author Tiberiu Craciun
  */

class CPrjConf {

public:
	CPrjConf (QString c, QString p ) { code=new QString(c); path=new QString(p); }

public: // Public attributes
  /**  */
  QString *path;
public: // Public attributes
  /**  */
  QString *code;
};

class TcpServer;


class CServer: public TcpServer {
  protected:

    void handle_client(int client_socket_fd);
  /**  */
  int GetDirs(QString directory,FILE *out, QString *prj );
  /**  */
  int GetFiles(QString directory,FILE *out, QString *prj );
  int CheckFile(QString file,FILE *out, QString *prj, int client_socket_fd );

  public:

  	 CServer(int port, int queue_size, char* log_file) :
    	TcpServer(port, queue_size, log_file)
	    {
  	  }
    virtual ~CServer(){};
    int SendFile(char* fname,FILE *out, QString *prj);
    int PutFile(char* fname,FILE *in, QString *prj);
    char* GetCommand(FILE *in);
    int InterpretCommand(char* cmd,FILE *in,FILE *out, QString *prj, int client_socket_fd );
    char* receive(FILE *in);
    int HaveAccess();
    int Lock(char *filename,FILE *out,QString *prj, int client_socket_fd);
    int Unlock(char *filename,FILE *out,QString *prj, int client_socket_fd);
    int ChangePassword(char *user,char *pass);
    int AddUser(char *user);
    int AddFile(char *filename,QString *prj);
    int DelFile(char *filename,QString *prj);
    int AddDir(char *dirname,QString *prj);
    int DelDir(char *dirname,QString *prj);
	  int ChangeProject(char *prj);
		QString Path(QString *prj);
  /**  */
  int addProject(QString code, QString path);
  /**  */

private:
     char *username;
     char *password;
protected: // Protected attributes
  /**  */
  QList<CPrjConf> prjList;
public: // Public attributes
  char *wwwRoot;
};

#endif























