/***************************************************************************
                          main.cpp  -  description
                             -------------------
    begin                : Sun Nov 21 1999
    copyright            : (C) 1999 by Tiberiu Craciun
    email                : tiberiu@akela.ro
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <fstream.h>
#include <iostream.h>

#include "cserver.h"
#include "cmainconfig.h"

int main(int c, char** argv)
 {
  CMainConfig config("/etc/kphpdev");
  QString p, l, ip, www, prj;
  char *ip_rules_file = NULL, *log;

  p=config.getPort();
  l=config.getLogFile();
  ip=config.getIPRulesFile();
	www=config.getWWWRoot();
	l=l.stripWhiteSpace();
	ip=ip.stripWhiteSpace();
	www=www.stripWhiteSpace();
	cout << "K PHP Develop Server daemon  is starting ...	\n\n";
  if(p.length()==0){
			cout << " Port was not found ! Check config file !\n";
			cout << "\nK PHP Develop Server daemon was not started !\n";
			exit(1);
	}
  cout << "Port: " << p.toInt() << "\n";
  cout << "Log file: " ;
  if(l.isNull() || l.isEmpty()){
			log = NULL;
			cout << " None \n";
	}else{
			log = qstrdup(l);
			cout << log << "\n";
	}
  cout << "IP rules file:";
  if(ip.isNull() || ip.isEmpty()){
			ip_rules_file = NULL;
			cout << " None \n";
	}else{
			ip_rules_file = qstrdup(ip);
			cout << ip_rules_file << "\n";
	}
  CServer s(p.toInt(), 50,log);
  if(ip_rules_file)
   {
    ifstream rules(ip_rules_file);
    if(!rules)
    {
     cout << "Could not open rules file !" << endl;
		 cout << "\nK PHP Develop Server daemon was not started !\n";
     exit(1);
    }

    while(1)
    {
     char netnum[128], netmask[128];
     rules >> netnum >> netmask;
     cout << "reading: " << netnum << " " << netmask << endl;
     if(!rules) break;
     s.add_ip_rule(netnum, netmask);
    }
    s.enable_access_control();
   }

  if(www.isNull() || www.isEmpty()){
		cout << "\nWWW Root Directory was not found ! Check config file ! \n";
		cout << "\nK PHP Develop Server daemon was not started !\n";
		exit(1);
	}else{
		if(www.right(1)!="/"){
			www+="/";
		}
		s.wwwRoot=qstrdup(www);
		cout << "WWW Root Directory: "<< s.wwwRoot <<"\n" ;
	}

	cout << "\nAdding projects ...\n";
  prj=config.getProjects();
	if(prj.right(1)!=",	"){
		prj+=",";
	}
	int index=0,ind, nrprj=0;
	QString pr;
	QString prj_name_QS;
	char *prj_name;
	while((ind=prj.find(',',index,FALSE))!=-1){
		pr=prj.mid(index,ind-index);
		prj_name_QS = config.getProject(pr);
		if(prj_name_QS.right(1)!="/"){
			prj_name_QS+="/";
		}
		prj_name = qstrdup(prj_name_QS);
		cout << "\t" << pr << ": " << prj_name << "\n";
		index=ind+1;
		s.addProject(pr,prj_name_QS);
		nrprj++;
	}
	cout << nrprj << " projects added !\n";

	cout << "\nK PHP Develop Server daemon is runing ! \n";
  s.run_server();
 }














